| http://www.sim.no/ http://www.coin3d.org/

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoVRMLSwitch Class Reference
VRML97 Classes

The SoVRMLSwitch class is a group node for traversing selected children.The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium: More...

`#include <Inventor/VRMLnodes/SoVRMLSwitch.h>`

Inheritance diagram for SoVRMLSwitch:

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoVRMLSwitch (void)
| SoVRMLSwitch (int choices)
virtual SbBool | affectsState (void) const
void | addChoice (SoNode *choice)
void | insertChoice (SoNode *choice, int idx)
SoNode * | getChoice (int idx) const
int | findChoice (SoNode *choice) const
int | getNumChoices (void) const
void | removeChoice (int idx)
void | removeChoice (SoNode *node)
void | removeAllChoices (void)
void | replaceChoice (int idx, SoNode *choice)
void | replaceChoice (SoNode *old, SoNode *choice)
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
void | addChild (SoNode *child)
void | insertChild (SoNode *child, int idx)
SoNode * | getChild (int idx) const
int | findChild (const SoNode *child) const
int | getNumChildren (void) const
void | removeChild (int idx)
void | removeChild (SoNode *child)
void | removeAllChildren (void)
void | replaceChild (int idx, SoNode *node)
void | replaceChild (SoNode *old, SoNode *node)
virtual SoChildList * | getChildren (void) const
Public Member Functions inherited from SoGroup
| SoGroup (void)
| SoGroup (int nchildren)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
uint32_t | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoGroup
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoMFNode | choice
SoSFInt32 | whichChoice

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoVRMLSwitch (void)
virtual void | notify (SoNotList *list)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | copyContents (const SoFieldContainer *from, SbBool copyConn)
Protected Member Functions inherited from SoGroup
virtual | ~SoGroup ()
virtual SbBool | readChildren (SoInput *in)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoGroup
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)

## Additional Inherited Members

Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000 }
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Protected Attributes inherited from SoGroup
SoChildList * | children
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoVRMLSwitch class is a group node for traversing selected children.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

    Switch {
      exposedField    MFNode  choice      []
      exposedField    SFInt32 whichChoice -1    # [-1, inf)
    }

The Switch grouping node traverses zero or one of the nodes specified in the choice field. 4.6.5, Grouping and children nodes (http://www.web3d.org/x3d/specifications/vrml/ISO-IEC-14772-VRML97/part1/concepts.html#4.6.5), describes details on the types of nodes that are legal values for choice.

The whichChoice field specifies the index of the child to traverse, with the first child having index 0. If whichChoice is less than zero or greater than the number of nodes in the choice field, nothing is chosen. All nodes under a Switch continue to receive and send events regardless of the value of whichChoice. For example, if an active SoVRMLTimeSensor is contained within an inactive choice of an Switch, the SoVRMLTimeSensor sends events regardless of the Switch's state.

## Constructor & Destructor Documentation

SoVRMLSwitch::SoVRMLSwitch | ( | void | ) |  |

Constructor.

SoVRMLSwitch::SoVRMLSwitch | ( | int | choices) |  |

Constructor. choices is the expected number of children.

SoVRMLSwitch::~SoVRMLSwitch | ( | void | ) |  |

protectedvirtual

Destructor.

## Member Function Documentation

SoType SoVRMLSwitch::getTypeId | ( | void | ) |  | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Reimplemented from SoGroup.

const SoFieldData * SoVRMLSwitch::getFieldData | ( | void | ) |  | const

protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoGroup.

SbBool SoVRMLSwitch::affectsState | ( | void | ) |  | const

virtual

Returns `TRUE` if the node could have any effect on the state during traversal.

If it returns `FALSE`, no data in the traversal-state will change from the pre-traversal state to the post-traversal state. The SoSeparator node will for instance return `FALSE`, as it pushes and pops the state before and after traversal of its children. All SoShape nodes will also return `FALSE`, as just pushing out geometry data to the rendering engine won't affect the actual rendering state.

The default method returns `TRUE`, on a "better safe than sorry" philosophy.

Reimplemented from SoNode.

void SoVRMLSwitch::addChoice | ( | SoNode * | choiceptr) |  |

Adds choice to the choice field.

void SoVRMLSwitch::insertChoice | ( | SoNode * | choiceptr,
|  | int | idx
| ) |  |

Inserts choice at index idx.

SoNode * SoVRMLSwitch::getChoice | ( | int | idx) |  | const

Returns the choice at index idx.

int SoVRMLSwitch::findChoice | ( | SoNode * | choiceptr) |  | const

Finds the index for choice, or -1 if not found.

int SoVRMLSwitch::getNumChoices | ( | void | ) |  | const

Returns the number of choices.

void SoVRMLSwitch::removeChoice | ( | int | idx) |  |

Removes the choice at index idx.

void SoVRMLSwitch::removeChoice | ( | SoNode * | choiceptr) |  |

If choice is found, remove it.

void SoVRMLSwitch::removeAllChoices | ( | void | ) |  |

Removes all choices.

void SoVRMLSwitch::replaceChoice | ( | int | idx,
|  | SoNode * | choiceptr
| ) |  |

Replace the choice at index idx with choice.

void SoVRMLSwitch::replaceChoice | ( | SoNode * | old,
|  | SoNode * | choiceptr
| ) |  |

Find old, and replace it with choice.

void SoVRMLSwitch::doAction | ( | SoAction * | action) |  |

virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoGroup.

void SoVRMLSwitch::callback | ( | SoCallbackAction * | action) |  |

virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoGroup.

void SoVRMLSwitch::GLRender | ( | SoGLRenderAction * | action) |  |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method.

Reimplemented from SoGroup.

void SoVRMLSwitch::pick | ( | SoPickAction * | action) |  |

virtual

Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoGroup.

void SoVRMLSwitch::getBoundingBox | ( | SoGetBoundingBoxAction * | action) |  |

virtual

Action method for the SoGetBoundingBoxAction.

Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node.

Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables.

Reimplemented from SoGroup.

void SoVRMLSwitch::handleEvent | ( | SoHandleEventAction * | action) |  |

virtual

Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also overrides this method.

Reimplemented from SoGroup.

void SoVRMLSwitch::getMatrix | ( | SoGetMatrixAction * | action) |  |

virtual

Action method for SoGetMatrixAction.

Updates action by accumulating with the transformation matrix of this node (if any).

Reimplemented from SoGroup.

void SoVRMLSwitch::search | ( | SoSearchAction * | action) |  |

virtual

Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction – if any of the requested criteria is a miss, the search is not deemed successful for the node.

See Also
  SoSearchAction

Reimplemented from SoGroup.

void SoVRMLSwitch::write | ( | SoWriteAction * | action) |  |

virtual

Action method for SoWriteAction.

Writes out a node object, and any connected nodes, engines etc, if necessary.

Reimplemented from SoGroup.

void SoVRMLSwitch::audioRender | ( | SoAudioRenderAction * | action) |  |

virtual

Action method for SoAudioRenderAction.

Does common processing for SoAudioRenderAction action instances.

Reimplemented from SoGroup.

void SoVRMLSwitch::addChild | ( | SoNode * | node) |  |

virtual

Append a child node to the list of children nodes this group node is managing.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

void SoVRMLSwitch::insertChild | ( | SoNode * | child,
|  | int | newchildindex
| ) |  |

virtual

Insert a child node at position newchildindex.

newchildindex must be <= this->getNumChildren()

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

SoNode * SoVRMLSwitch::getChild | ( | int | index) |  | const

virtual

Returns pointer to child node at index.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

int SoVRMLSwitch::findChild | ( | const SoNode * | node) |  | const

virtual

Returns index in our list of children for child node, or -1 if node is not a child of this group node.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

int SoVRMLSwitch::getNumChildren | ( | void | ) |  | const

virtual

Returns number of child nodes managed by this group.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

void SoVRMLSwitch::removeChild | ( | int | childindex) |  |

virtual

Remove node at childindex in our list of children.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

void SoVRMLSwitch::removeChild | ( | SoNode * | child) |  |

virtual

Remove child from the set of children managed by this group node. Will decrease the reference count of child by 1.

This is a convenience method. It will simply call findChild() with child as argument, and then call removeChild(int) if the child is found.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

void SoVRMLSwitch::removeAllChildren | ( | void | ) |  |

virtual

Do not manage the children anymore. Will dereference all children by 1 as they are removed.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

void SoVRMLSwitch::replaceChild | ( | int | index,
|  | SoNode * | newchild
| ) |  |

virtual

Replace child at index with newChild.

Dereferences the child previously at index, and increases the reference count of newChild by 1.

index must be < this->getNumChildren()

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

void SoVRMLSwitch::replaceChild | ( | SoNode * | oldchild,
|  | SoNode * | newchild
| ) |  |

virtual

Replace oldchild with newchild.

Dereferences oldchild by 1, and increases the reference count of newchild by 1.

This is a convenience method. It will simply call findChild() with oldchild as argument, and call replaceChild(int, SoNode*) if the child is found.

Please note that this method is not virtual in the original SGI Inventor API.

Reimplemented from SoGroup.

SoChildList * SoVRMLSwitch::getChildren | ( | void | ) |  | const

virtual

Returns list of children.

Reimplemented from SoGroup.

void SoVRMLSwitch::notify | ( | SoNotList * | l) |  |

protectedvirtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

SbBool SoVRMLSwitch::readInstance | ( | SoInput * | in,
|  | unsigned short | flags
| ) |  |

protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistant representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went ok or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoGroup.

void SoVRMLSwitch::copyContents | ( | const SoFieldContainer * | from,
|  | SbBool | copyconnections
| ) |  |

protectedvirtual

Makes a deep copy of all data of from into this instance, except external scenegraph references if copyconnections is `FALSE`.

This is the protected method that should be overridden by extension node / engine / dragger / whatever subclasses which needs to account for internal data that are not handled automatically.

For copying nodes from application code, you should not invoke this function directly, but rather call the SoNode::copy() function:

SoNode * mynewnode = templatenode->copy();

The same also goes for engines.

Make sure that when you override the copyContents() method in your extension class that you also make it call upwards to it's parent superclass in the inheritance hierarchy, as copyContents() in for instance SoNode and SoFieldContainer does important work. It should go something like this:

void
MyCoinExtensionNode::copyContents(const SoFieldContainer * from,
SbBool copyconnections)
{
// let parent superclasses do their thing (copy fields, copy
// instance name, etc etc)
SoNode::copyContents(from, copyconnections);
// [..then copy internal data..]
}

Reimplemented from SoGroup.

## Member Data Documentation

SoMFNode SoVRMLSwitch::choice

Contains the children.

SoSFInt32 SoVRMLSwitch::whichChoice

Selected choice. Can be a positive number from 0 to <num children-1>="">, or one of the constants SO_SWITCH_NODE, SO_SWITCH_ALL or SO_SWITCH_INHERIT. Default value is SO_SWITCH_NONE.

The documentation for this class was generated from the following files:

- SoVRMLSwitch.h
- Switch.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.